<template>
  <section class="section-login container">
    <h1>Вход</h1>
    <form @submit.prevent="login">
      <label><span class="visually-hidden">Email: </span><input type="email" v-model="user.email" placeholder="regular.user@course-project.ru" required></label>
      <label><span class="visually-hidden">Пароль: </span><input type="password" v-model="user.password" required></label>
      <input type="submit" value="Войти">
      <p class="text-danger" v-if="errorMessage">{{this.errorMessage}}</p>
    </form>
  </section>
</template>

<script>
import axios from 'axios'

export default {
  name: "Login",
  data() {
    return {
      user: {
        email: 'regular.user@course-project.ru',
        password: 'TestMyApp1',
      },
      errorMessage: ''
    }
  },
  methods: {
    login() {
      axios
          .post('auth/login/', structuredClone(this.user))
          .then(response => {
            const token = response.data.access
            this.$store.commit('setToken', token)
            axios.defaults.headers.common['Authorization'] = `Bearer ${token}`
            localStorage.setItem('token', token)
            // noinspection JSCheckFunctionSignatures
            this.$router.replace(this.$route.query.redirect || '/')
          })
          .catch(({response: {data: {error}}}) => {
            this.errorMessage = error
          })
    }
  }
}
</script>

<style scoped>

</style>